-- `xero` is the only global variable written by this template
-- Everything, including the modder's variables are stored in it
xero = {
	MIRIN_VERSION = '5.0.0',
	dir = GAMESTATE:GetCurrentSong():GetSongDir(),
}

-- Load all of the core .lua files
-- The order DOES matter here:
-- std.lua needs to be loaded first
-- template.lua needs to be last
loadfile(xero.dir..'template/std.lua')()
loadfile(xero.dir..'template/sort.lua')()
loadfile(xero.dir..'template/ease.lua')()
loadfile(xero.dir..'template/template.lua')()
assert(loadfile(xero.dir..'template/plugins.lua'))()

--Bring in standard mods & aliases.
loadfile(xero.dir..'template/compat.lua')()

return Def.ActorFrame{
	InitCommand= function(self) xero.foreground = self end,
	OnCommand= function(self)
		-- Needed by StepMania, in order to not kill lua mods early
		self:sleep(9e9)
	end,
	Def.ActorFrame{
		InitCommand= xero.init_command,
	},
	assert(loadfile(xero.dir..'lua/layout.lua'))(),
}
