--THE FUTURE OF ENTERTAINMENT AND MODIFIERS 2016
--(C) TaroNuke

--Note: may be missing one or two mods.....
local func = {}
local mod_strSplit = function(str, delim, maxNb)
	-- Eliminate bad cases...
	if string.find(str, delim) == nil then
		return { str }
	end
	if maxNb == nil or maxNb < 1 then
		maxNb = 0    -- No limit
	end
	local result = {}
	local pat = '(.-)' .. delim .. '()'
	local nb = 0
	local lastPos--gfind -> gmatch
	for part, pos in string.gmatch(str, pat) do
		nb = nb + 1
		result[nb] = part
		lastPos = pos
		if nb == maxNb then break end
	end
	-- Handle the last field
	if nb ~= maxNb then
		result[nb + 1] = string.sub(str, lastPos)
	end
	return result
end

func.split = function(po,val,spd)
	po:Split(val,spd)
end
func.alternate = function(po,val,spd)
	po:Alternate(val,spd)
end
func.cross = function(po,val,spd)
	po:Cross(val,spd)
end
func.reverse = function(po,val,spd)
	po:Reverse(val,spd)
end
func.centered = function(po,val,spd)
	po:Centered(val,spd)
end

func.flip = function(po,val,spd)
	po:Flip(val,spd)
end

func.invert = function(po,val,spd)
	po:Invert(val,spd)
end

func.xmode = function(po,val,spd)
	po:Xmode(val,spd)
end

func.dizzy = function(po,val,spd)
	po:Dizzy(val,spd)
end
func.twirl = function(po,val,spd)
	po:Twirl(val,spd)
end
func.roll = function(po,val,spd)
	po:Roll(val,spd)
end
func.confusion = function(po,val,spd)
	po:Confusion(val,spd)
end

func.beat = function(po,val,spd)
	po:Beat(val,spd)
end
func.bumpy = function(po,val,spd)
	po:Bumpy(val,spd)
end
func.drunk = function(po,val,spd)
	po:Drunk(val,spd)
end
func.tipsy = function(po,val,spd)
	po:Tipsy(val,spd)
end
func.tornado = function(po,val,spd)
	po:Tornado(val,spd)
end
func.wave = function(po,val,spd)
	po:Wave(val,spd)
end
func.expand = function(po,val,spd)
	po:Expand(val,spd)
end

func.boost = function(po,val,spd)
	po:Boost(val,spd)
end
func.brake = function(po,val,spd)
	po:Brake(val,spd)
end

func.dark = function(po,val,spd)
	po:Dark(val,spd)
end
func.blind = function(po,val,spd)
	po:Blind(val,spd)
end
func.cover = function(po,val,spd)
	po:Cover(val,spd)
end

func.stealth = function(po,val,spd)
	po:Stealth(val,spd)
end
func.hidden = function(po,val,spd)
	po:Hidden(val,spd)
end
func.sudden = function(po,val,spd)
	po:Sudden(val,spd)
end
func.hiddenoffset = function(po,val,spd)
	po:HiddenOffset(val,spd)
end
func.suddenoffset = function(po,val,spd)
	po:SuddenOffset(val,spd)
end
func.blink = function(po,val,spd)
	po:Blink(val,spd)
end

func.overhead = function(po,val,spd)
	po:Overhead(val,spd)
end
func.hallway = function(po,val,spd)
	po:Hallway(val,spd)
end
func.distant = function(po,val,spd)
	po:Distant(val,spd)
end
func.incoming = function(po,val,spd)
	po:Incoming(val,spd)
end
func.space = function(po,val,spd)
	po:Space(val,spd)
end

func.boomerang = function(po,val,spd)
	po:Boomerang(val,spd)
end

func.mini = function(po,val,spd)
	po:Mini(val,spd)
end
func.tiny = function(po,val,spd)
	po:Tiny(val,spd)
end
--Turns out we were missing some mods. -Kid
func.randomvanish = function(po,val,spd)
	po:RandomVanish(val,spd)
end
--I added these three func.functions. -Kid
func.scrollspeed = function(po,val,spd)--We need these for combining CMod and XMod.
	po:ScrollSpeed(val,spd)
end
func.timespacing = function(po,val,spd)--We need these for combining CMod and XMod.
	po:TimeSpacing(val,spd)
end
func.scrollbpm = function(po,val,spd)--We need these for combining CMod and XMod.
	po:ScrollBPM(val,spd)
end

func.clearall = function(po)
	po:RandomVanish(0,1)
	po:Split(0,1)
	po:Alternate(0,1)
	po:Cross(0,1)
	po:Mini(0,1)
	po:Tiny(0,1)
	po:Hallway(0,1)
	po:Distant(0,1)
	po:Incoming(0,1)
	po:Space(0,1)
	po:Beat(0,1)
	po:Bumpy(0,1)
	po:Wave(0,1)
	po:Expand(0,1)
	po:Drunk(0,1)
	po:Tipsy(0,1)
	po:Boost(0,1)
	po:Brake(0,1)
	po:Dizzy(0,1)
	po:Twirl(0,1)
	po:Roll(0,1)
	po:Confusion(0,1)
	po:Flip(0,1)
	po:Invert(0,1)
	po:Xmode(0,1)
	po:Tornado(0,1)
	po:Reverse(0,1)
	po:Centered(0,1)
	po:Stealth(0,1)
	po:Hidden(0,1)
	po:Sudden(0,1)
	po:HiddenOffset(0,1)
	po:SuddenOffset(0,1)
	po:Blink(0,1)
	po:Dark(0,1)
	po:Blind(0,1)
	po:Cover(0,1)
	--po:XMod(1,1)
	po:TimeSpacing(0,1)--xmods. -Kid
	po:ScrollSpeed(1,1)--xmods. -Kid
	po:Boomerang(0,1)
	po:RandomVanish(0,1)
	po:RandAttack(0,1)
	po:NoAttack(0,1)
	po:PlayerAutoPlay(0,1)
	po:Tilt(0,1)
	po:Skew(0,1)
	po:Passmark(0,1)
	po:RandomSpeed(0,1)
end

func.xmod = function(po,val,spd)--No, let's redo XMod and CMod. -Kid
	--po:XMod(val,spd)
        --SCREENMAN:SystemMessage("XMod("..val..","..spd..")")
	po:TimeSpacing(0,spd)
	po:ScrollSpeed(val,spd)
end
func.cmod = function(po,val,spd)--No, let's redo XMod and CMod. -Kid
	--po:CMod(val,spd)
	po:TimeSpacing(1,spd)
	po:ScrollBPM(val,spd)
end
func.mmod = function(po,val,spd)
	po:MMod(val,spd)
end

return function(str, pn)
	if pn and type(pn) == "number" then pn = 'PlayerNumber_P' .. pn end
	local ps = GAMESTATE:GetPlayerState(pn)
	local po = ps:GetPlayerOptions('ModsLevel_Song')
	
	local m = mod_strSplit(str,',')
	
	for i=1,#m do
		local mod = mod_strSplit(m[i],' ')
		
		if mod[1] == ' ' or mod[1] == '' or not mod[1] then
			table.remove(mod,1)
		end
		
		if mod == {'clearall'} then
			func.clearall(po)
		elseif #mod == 1 then
			if tonumber(string.sub(mod[1],1,-2)) and string.lower(string.sub(mod[1],-1)) == 'x' then
				func.xmod(po,tonumber(string.sub(mod[1],1,-2)),1)
			elseif tonumber(string.sub(mod[1],2)) and string.lower(string.sub(mod[1],1,1)) == 'c' then
				func.cmod(po,tonumber(string.sub(mod[1],2)),1)
			elseif tonumber(string.sub(mod[1],2)) and string.lower(string.sub(mod[1],1,1)) == 'm' then
				func.mmod(po,tonumber(string.sub(mod[1],2)),1)
			elseif func[string.lower(mod[1])] then
				func[string.lower(mod[1])](po,1,1)
			end
		elseif #mod == 2 then
			if string.sub(mod[1],1,1) == '*' then
				if tonumber(string.sub(mod[2],1,-2)) and string.lower(string.sub(mod[2],-1)) == 'x' then
					func.xmod(po,tonumber(string.sub(mod[2],1,-2)),tonumber(string.sub(mod[1],2)))
				elseif tonumber(string.sub(mod[2],2)) and string.lower(string.sub(mod[2],1,1)) == 'c' then
					func.cmod(po,tonumber(string.sub(mod[2],2)),tonumber(string.sub(mod[1],2)))
				elseif tonumber(string.sub(mod[2],2)) and string.lower(string.sub(mod[2],1,1)) == 'm' then
					func.mmod(po,tonumber(string.sub(mod[2],2)),tonumber(string.sub(mod[1],2)))
				elseif func[string.lower(mod[2])] then
					func[string.lower(mod[2])](po,1,tonumber(string.sub(mod[1],2)))
				end
			else
				local amt = 100
				if not tonumber(string.sub(mod[1],1,-2)) or string.lower(mod[1]) == 'no' then
					amt = 0
				elseif string.sub(mod[1],-1) == '%' then
					amt = tonumber(string.sub(mod[1],1,-2))/100
				else
					amt = tonumber(mod[1])/100
				end
				func[string.lower(mod[2])](po,amt,1)
			end
		elseif #mod == 3 then
			if func[string.lower(mod[3])] then
				local amt = 100
				if not tonumber(string.sub(mod[2],1,-2)) or string.lower(mod[2]) == 'no' then
					amt = 0
				elseif string.sub(mod[2],-1) == '%' then
					amt = tonumber(string.sub(mod[2],1,-2))/100
				else
					amt = tonumber(mod[2])/100
				end
				func[string.lower(mod[3])](po,amt,tonumber(string.sub(mod[1],2)))
			end
		end
		
	end
end
